<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<div [class.chvote-content]="createMode">
  <mat-card id="baseEdit" class="parameter-edit" [class.read-only]="readOnly">
    <mat-card-header>
      <mat-card-title>{{'parameters.base.edit.title' | translate}}</mat-card-title>
      <mat-card-subtitle fxLayout fxLayoutAlign="space-between">
        <span>{{'parameters.base.edit.subtitle' | translate}}</span>
        <span *ngIf="!readOnly">{{'global.forms.fields.required' | translate}}</span>
      </mat-card-subtitle>
    </mat-card-header>
    <mat-card-content>
      <form [formGroup]="baseParametersForm" novalidate>
        <div fxLayout="row wrap" fxLayoutGap="25px">
          <mat-form-field fxFlex="50 0 200px">
            <input matInput
                   name="operationLongLabel"
                   formControlName="longLabel"
                   placeholder="{{'parameters.base.edit.form.fields.long-label.placeholder' | translate}}"
                   required>
            <mat-error *ngIf="baseParametersForm.get('longLabel').hasError('required')">
              {{'global.forms.errors.required' | translate}}
            </mat-error>
            <mat-error *ngIf="baseParametersForm.get('longLabel').hasError('maxlength')">
              {{'parameters.base.edit.form.fields.long-label.errors.max-value' | translate}}
            </mat-error>
          </mat-form-field>
          <mat-form-field fxFlex="25 0 150px">
            <input matInput
                   name="operationShortLabel"
                   formControlName="shortLabel"
                   placeholder="{{'parameters.base.edit.form.fields.short-label.placeholder' | translate}}"
                   required>
            <mat-error *ngIf="baseParametersForm.get('shortLabel').hasError('required')">
              {{'global.forms.errors.required' | translate}}
            </mat-error>
            <mat-error *ngIf="baseParametersForm.get('shortLabel').hasError('maxlength')">
              {{'parameters.base.edit.form.fields.short-label.errors.max-value' | translate}}
            </mat-error>
          </mat-form-field>

          <mat-form-field fxFlex="25 0 150px">
            <mat-placeholder>{{'parameters.base.edit.form.fields.date.placeholder' | translate}}</mat-placeholder>
            <mat-datetimepicker-toggle [for]="operationDatepicker" matSuffix></mat-datetimepicker-toggle>
            <mat-datetimepicker #operationDatepicker type="date" timeInterval="5"></mat-datetimepicker>
            <input matInput
                   name="operationDate"
                   formControlName="date"
                   [matDatetimepicker]="operationDatepicker"
                   [min]="now"
                   required
                   autocomplete="false">
            <mat-error
              *ngIf="baseParametersForm.get('date').touched && baseParametersForm.get('date').hasError('required')">
              {{'global.forms.errors.required' | translate}}
            </mat-error>
            <mat-error
              *ngIf="baseParametersForm.get('date').touched && baseParametersForm.get('date').hasError('matDatepickerMin')">
              {{'parameters.base.edit.form.errors.past-date' | translate}}
            </mat-error>
          </mat-form-field>
        </div>
      </form>
    </mat-card-content>
    <mat-card-actions *ngIf="!readOnly">
      <div fxLayout fxLayoutAlign="end">
        <button *ngIf="createMode"
                mat-button
                id="cancelButton"
                (click)="cancel()">{{'global.actions.cancel' | translate | uppercase}}
        </button>
        <button mat-raised-button
                [disabled]="!isFormModified()"
                id="saveButton"
                color="primary"
                (click)="save()">{{'global.actions.save' | translate | uppercase}}
        </button>
      </div>
    </mat-card-actions>
  </mat-card>
</div>
